/*       CLIP  BAR
																										 (X,Y)
													 +-----+                      +------+
													 |  B  |                      |      | DY
													 +-----+                      +------+
																													 DX
								(0,0)   	 +-----+
									+--------+--E--+-----------+
									|        +-----+           |
									|                          |
									|                          |
	+-----+ 		 +--+--+	   +-----+	      +--+--+        +-----+
	|  A	| 		 |  G  |     |  I  |        |  H  |        |  C  |
	+-----+ 		 +--+--+	   +-----+       	+--+--+        +-----+
									|                          |
									|                          |
									|		  	 +-----+           |
									+--------+--F--+-----------+
													 +-----+          (XMAX,YMAX)

													 +-----+
													 |  D  |
													 +-----+

*/
#ifdef never_execute
//CLIP_BLOCK(x_org, y_org, x_dest, y_dest, dx,dy, XMax, YMax);
if(x_dest<0 || y_dest<0 || x_dest+dx > XMax || y_dest+dy > YMax) { // !I
	if(x_dest+dx <= 0) return;                                       // A
	if(y_dest+dy <= 0) return;                                       // B
	if(x_dest >= XMax) return;                                       // C
	if(y_dest >= YMax) return;                                       // D

	if(y_dest<0) { dy = dy+y_dest; y_org=-y_dest; y_dest=0;}         // E
	if(y_dest+dy > YMax) { dy = YMax-y_dest; }                  // F

	if(x_dest<0) { dx = dx+x_dest; x_org=-x_dest; x_dest=0; }        // G
	if(x_dest+dx > XMax) { dx = XMax-x_dest; }                  // H
}
#endif


#define CLIP_BLOCK(x_org, y_org, x_dest, y_dest, dx,dy, XMax, YMax)\
if(x_dest<0  ||  y_dest<0  ||  x_dest+dx > XMax  ||  y_dest+dy > YMax) { \
	if(x_dest+dx <= 0) return;																	           \
	if(y_dest+dy <= 0) return;																						 \
	if(x_dest >= XMax) return;																						 \
	if(y_dest >= YMax) return;                                  					 \
																																				 \
	if(y_dest<0) { dy = dy+y_dest; y_org=-y_dest; y_dest=0;}    					 \
	if(y_dest+dy > YMax) { dy = YMax-y_dest; }                  					 \
																																				 \
	if(x_dest<0) { dx = dx+x_dest; x_org=-x_dest; x_dest=0; }   					 \
	if(x_dest+dx > XMax) { dx = XMax-x_dest; }             					       \
}





/*
CLIP HLINE

																							(x,y)
						 (0,0)			---G---                    -----------
									+------------------+                  dx
			---A---     |                  |
							----B----              |
									|                  |
							 ---+--------C---------+---
									|                  |
									|    ----D----     |
									|              ----E----
									|                  |  ---F---
									+------------------+
												---H---      (XMax,YMax)


*/
#ifdef never_execute
if(y<0 || y>=YMax) return;  // G, H
if(x<0 || x+dx>XMax) {
	if(x<0) {            // A, B, C
		dx=dx+x; x=0;      //    B, C
		if(dx<=0) return;  // A
	}                    //
	if(x+dx>XMax) {      // C, E, F
		dx=XMax-x;         // C, E
		if(x>XMax) return; //       F
	}
}
#endif




// MACRO TO CLIP HORIZONTAL LINES(x,y,dx) TO A RECTANGLE(XMax,YMax)
#define CLIP_HLINE(x,y,dx,XMax,YMax)	\
																			\
if(y<0 || y>=YMax) return;            \
if(x<0 || x+dx>XMax) {                \
	if(x<0) {                           \
		dx=dx+x; x=0;                     \
		if(dx<=0) return;                 \
	}                                   \
	if(x+dx>XMax) {                     \
		dx=XMax-x;                        \
		if(x>XMax) return;                \
	}                                   \
}
