#include "Hyper.hpp"
#include "Message.hpp"

#include <conio.h>
#include <stdio.h>
#include <process.h>

extern MessageHandler message;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Hyper::Hyper(int max_hyperVal) {

	max_hyper = max_hyperVal;

	hyp = new st_hyp[max_hyper];
	message.Message(TO_FILE, "Hyper::Hyper  ' st_hyp allocated");

	Reset();

}

Hyper::~Hyper() {

	delete hyp;
	message.Message(TO_FILE, "Hyper::~Hyper  ' st_hyp deleted");

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Hyper::Reset(void) {
	int i;

	for(i=0; i<max_hyper; i++) {
		hyp[i].x0 = -1;
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Hyper::GetHyper(int x, int y) {
	int i;
	for(i=0; i<max_hyper; i++) {

		if(hyp[i].x0 != -1)
			if(hyp[i].x0<=x && x<=hyp[i].x1 && hyp[i].y0<=y && y<=hyp[i].y1) return i;
	}
	return -1;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Hyper::Define(int x, int y, int dx, int dy) {
	int n;

	for( n=0; n < max_hyper; n++) {
		if(hyp[n].x0 == -1) {
			hyp[n].x0 = x;
			hyp[n].y0 = y;
			hyp[n].x1 = x+dx-1;
			hyp[n].y1 = y+dy-1;

//			::Rectangle(x,y,dx,dy, 255,250,250);

			return n;
		}
	}

	printf("No more Hyper-regions available.\n");
	getch();

	return HYPER_DEF_ERROR;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Hyper::Free(int id) {

	if(id != HYPER_DEF_ERROR) hyp[id].x0 = -1;
	else printf("Attempt to free a non defined hyper-region");

}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Hyper::Redefine(int hyper_id, int x, int y, int dx, int dy) {
	if(hyper_id != HYPER_DEF_ERROR) {
		hyp[hyper_id].x0 = x;
		hyp[hyper_id].y0 = y;
		hyp[hyper_id].x1 = x+dx-1;
		hyp[hyper_id].y1 = y+dy-1;
	}

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Hyper::Availability(void) {
	int n;
	int count=0;

	for(n=0; n < max_hyper; n++) if(hyp[n].x0 == -1) count++;

	return count;
}
