#ifndef __IMAGE
#define __IMAGE

const int ERROR = 1;
const int OK    = 0;

#include "GraphDev.hpp"

enum enum_read_write { READ_ONLY, READ_WRITE };
//enum enum_storage {	IMG_FILE,	IMG_XMS };

class Image: public GraphicDevice {

	public:

		char *file_name;
		char file_name_allocated;
		char read_write;
		char temporary_image;

	public:

		virtual int New(char *file_name, int dx, int dy)=0;  // if file_name=="" => temporal file with random name
		virtual int Open(char *file_name, enum enum_read_write mode=READ_WRITE, int preview=1)=0;
		virtual void Close(void)=0;
		virtual int SaveAs(char *file_name)=0;

		virtual int ReDim(int dx, int dy)=0;

		virtual void SetPixelNoClip(int x, int y,	RGB &rgb)=0;
		virtual RGB GetPixelNoClip(int x, int y)=0;
		virtual void SetHLineNoClip(unsigned char *source, int x, int y, int dx)=0;
		virtual void GetHLineNoClip(unsigned char *dest, int x, int y, int dx)=0;


};



#endif