#include "GraphDev.hpp"
#include "RGB.hpp"
#include "Image.hpp"
#include "XMS.hpp"


#ifndef __ImgXMS
#define __ImgXMS

#include <stdio.h>


class ImgXMS: public Image {  //  : public GraphicDevice

	private:
		XMS_HANDLE handle;

	public:
		ImgXMS(void);
		~ImgXMS();

//		int Create(char *file_name, int dx, int dy, enum enum_storage storage);  // if file_name=="" => temporal file with random name
		int New(char *file_name, int dx, int dy);
		int Open(char *file_name, enum enum_read_write mode=READ_WRITE, int preview=1);
		void Close(void);
		int SaveAs(char *file_name);
		int ReDim(int dx, int dy);

		void SetPixelNoClip(int x, int y,	RGB &rgb);
		RGB GetPixelNoClip(int x, int y);
		void HLineNoClip(int x0, int y0, int dx, RGB& rgb); // Horizontal line
		void SetHLineNoClip(unsigned char *source, int x, int y, int dx);
		void GetHLineNoClip(unsigned char *dest, int x, int y, int dx);


};



#endif