#include "Message.hpp"
#include "Screen.hpp"

#include <stdio.h>
#include <stdarg.h>
#include <process.h>
#include <string.h>
#include <conio.h>
#include <dos.h>

extern Screen screen;

unsigned int MessageHandler::message_count=0;   // static class member

//----------------------------------------------------------------------------
//    Constructor & Destructor
//----------------------------------------------------------------------------
MessageHandler::MessageHandler(char *file_nameVal,
	unsigned int default_attrVal, int clear_file) {

	default_attr = default_attrVal;

	file_name = new char[strlen(file_nameVal+1)];
	strcpy(file_name, file_nameVal);

	if(clear_file==0) DeleteFile();

	Message(TO_FILE,"\
--------------------------NEW--EXECUTION----------------------------------");

}

MessageHandler::~MessageHandler(void) {

//	Message(TO_FILE,"\
//------------------------END--OF--EXECUTION--------------------------------\n");

	delete file_name;

}

//----------------------------------------------------------------------------
//    Output depending on video mode
//----------------------------------------------------------------------------
void MessageHandler::print_string(char *string, int attr) {

	if(attr&NUMBER) screen.PrintF(string);
	else screen.PrintF(string+6);
}


//----------------------------------------------------------------------------
//    Delete ERROR_FILE
//----------------------------------------------------------------------------
void MessageHandler::DeleteFile(void) {
	unlink(file_name);
}

/*----------------------------------------------------------------------------
													 Message
												1st version (default attr)

	format = same as printf

	WARNING: attempt to write more than MAX_CHAR_IN_WRITE caracters
						will be disastrous
----------------------------------------------------------------------------*/
unsigned int MessageHandler::Message(char *format,...) {
	unsigned int key;

	va_list argptr;
	va_start(argptr, format);

	key = vmessage(default_attr, format, argptr);

	va_end(argptr);

	return key;

}
/*----------------------------------------------------------------------------
													 Message
												2st version

	format = same as printf

	WARNING: attempt to write more than MAX_CHAR_IN_WRITE caracters
						will be disastrous
----------------------------------------------------------------------------*/
unsigned int MessageHandler::Message(int attr, char *format,...) {

	unsigned int key;

	va_list argptr;
	va_start(argptr, format);

	key = vmessage(attr, format, argptr);

	va_end(argptr);

	return key;

}

/*----------------------------------------------------------------------------
													 vmessage
										 private sub function
----------------------------------------------------------------------------*/
unsigned int MessageHandler::vmessage(int attr, char *format, va_list argptr){
	char string[MAX_CHAR_IN_FORMAT_STRING];   // max number of characters to write


	sprintf(string, "%4.4X: ", message_count);
	message_count++;

	vsprintf(string+strlen(string), format, argptr);

	strcat(string, "\n");

	// exits via exit(1) after display the message in Text mode
	if(attr & EXIT) {
		if(screen.is_graphic_mode) screen.CloseGraph();
	}

	// write message on screen
	if(attr & TO_SCREEN) MessageHandler::print_string(string, attr);

	// write message to file
	if(attr & TO_FILE) {
		FILE *fp;
		if ((fp=fopen(file_name, "ab")) == NULL) {
			Message(EXIT | TO_SCREEN | BEEP, "Cannot open MessageHandler file <%s>.\nCheck 'MessageHandler' constructor call.\n", file_name);
		}
		fwrite(string, 1, strlen(string), fp);
		fclose(fp);
	}

	// produces a beep
	if(attr & BEEP) {
		sound(1000);
		delay(100);
		nosound();
	}

	// wait for a key to be pressed and returns its code
	if(attr & WAIT_KEY) {
		unsigned int c;
		while(kbhit()) getch();
		if( (c=getch()) == 0x00 ) return getch()<<8;
		return c;
	}

	// exits via exit(1) after display the message in Text mode
	if(attr & EXIT) {
		Message(TO_SCREEN, "\nThanks for your visit.");
		exit(1);
	}

	return 0;

}
