/*----------------------------------------------------------------------------

													MESSAGE HANDLER

//----------------------------------------------------------------------------
// Manuel Guillen Gonzalez 31/10/96

How to init the class:   define object this way:
								MessageHandler error;
 and define
								extern error;
 in all other modules.
																		 */

// When attr=0: 	write TO SCREEN
//								write TO FILE
//								does NOT WAIT KEY and
//								does NOT EXIT

// EXAMPLE: error.Message(WAIT_KEY || EXIT, "Error %i. press a key to exit", n);
// Default '0': to_file, to screen, no wait key, no beep, no exit

	#define TO_SCREEN	 1    // write the message on the screen
	#define TO_FILE		 2		// write the message to the file ERROR_FILE_NAME

	#define WAIT_KEY   4    // wait for a key to be pressed

	#define NUMBER     8    // prints 'number_of_message: text' on the screen
	#define BEEP       16   // beeps after displaying the message
	#define EXIT       32   // exits via exit(1) after display the message


// WARNING: DO NOT EXCEED THIS LENGTH ANY ERROR MESSAGE:

#define MAX_CHAR_IN_FORMAT_STRING  300

#include <stdarg.h>


//----------------------------------------------------------------------------


class MessageHandler {

	public:
		static unsigned int message_count;  //incremented everytime Message() is called

	private:
		unsigned int default_attr;
		char *file_name;

	public:                                                 // clear_file=0 => delete
		MessageHandler(char *file_name, unsigned int default_attr=TO_FILE|TO_SCREEN, int clear_file=0); // clear_file=1 => no delete
		~MessageHandler();

		unsigned int Message(char *format,...);
		unsigned int Message(int attr, char *format,...);
		void DeleteFile(void);
		inline void SetDefaultAttr(unsigned int a) { default_attr = a; }


	private:
		void print_string(char *string, int attr);
		unsigned int vmessage(int attr, char *format, va_list argptr);

};




