#include "Mouse.hpp"
#include "Message.hpp"
#include "Screen.hpp"

#include <dos.h>
#include <stdio.h>
#include <conio.h>

extern Screen screen;
extern MessageHandler message;

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
unsigned char arrow[]={
	11,16,
	2,2,0,0,0,0,0,0,0,0,0,
	2,1,2,0,0,0,0,0,0,0,0,
	2,1,1,2,0,0,0,0,0,0,0,
	2,1,1,1,2,0,0,0,0,0,0,
	2,1,1,1,1,2,0,0,0,0,0,
	2,1,1,1,1,1,2,0,0,0,0,
	2,1,1,1,1,1,1,2,0,0,0,
	2,1,1,1,1,1,1,1,2,0,0,
	2,1,1,1,1,1,1,1,1,2,0,
	2,1,1,1,1,1,2,2,2,2,2,
	2,1,1,2,1,1,1,2,0,0,0,
	2,1,2,0,2,1,1,2,0,0,0,
	2,2,0,0,2,1,1,1,2,0,0,
	0,0,0,0,0,2,1,1,2,0,0,
	0,0,0,0,0,2,1,1,2,0,0,
	0,0,0,0,0,2,2,2,2,0,0
};

unsigned char timer[]={
	11,16,
	2,2,2,2,2,2,2,2,2,2,2,
	2,1,1,1,1,1,1,1,1,1,2,
	2,1,2,2,2,2,2,2,2,1,2,
	2,1,2,2,2,2,2,2,2,1,2,
	0,2,1,2,2,2,2,2,1,2,0,
	0,2,1,2,2,2,2,2,1,2,0,
	0,0,2,1,1,1,1,1,2,0,0,
	0,0,0,2,1,1,1,2,0,0,0,
	0,0,0,2,1,2,1,2,0,0,0,
	0,0,2,1,2,2,2,1,2,0,0,
	0,2,1,2,2,1,2,2,1,2,0,
	0,2,1,2,2,1,2,2,1,2,0,
	2,1,2,2,1,1,1,2,2,1,2,
	2,1,1,1,1,1,1,1,1,1,2,
	2,1,1,1,1,1,1,1,1,1,2,
	2,2,2,2,2,2,2,2,2,2,2
};


unsigned char arrow2[]={
	10,10,
	2,2,2,2,2,2,2,2,2,2,
	2,1,1,1,1,1,1,1,2,0,
	2,1,1,1,1,1,1,2,0,0,
	2,1,1,1,1,1,2,0,0,0,
	2,1,1,1,1,1,2,2,0,0,
	2,1,1,1,1,1,1,2,2,0,
	2,1,1,2,2,1,1,1,2,2,
	2,1,2,0,2,2,1,1,1,2,
	2,2,0,0,0,2,2,1,2,0,
	2,0,0,0,0,0,2,2,0,0,
};

unsigned char arrow3[]={
	6,14,
	2,2,2,0,0,0,
	2,1,2,0,0,0,
	2,1,2,0,0,0,
	2,1,2,0,0,0,
	2,1,1,2,0,0,
	2,1,1,2,0,0,
	2,1,1,2,0,0,
	2,1,1,1,2,0,
	2,1,1,1,2,0,
	2,1,1,1,2,0,
	2,1,1,1,1,2,
	2,1,1,1,1,2,
	2,1,1,1,1,2,
	2,2,2,2,2,2

};
/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
Mouse::Mouse(void) {
	background_buffer = new unsigned char [1];  // created only to be deleted at the start of the function SetCursorImage()
	foreground_buffer = new unsigned char [1];  // created only to be deleted at the start of the function SetCursorImage()
}

Mouse::~Mouse(void) {
	delete background_buffer;
	delete foreground_buffer;
}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
int Mouse::Init(void) {

	if(!screen.is_graphic_mode) {
		message.Message(TO_SCREEN|TO_FILE, "Mouse::Init  'Video mode not initialised' Can't init mouse");
		return MOUSE_ERROR;
	}

	// install mouse driver
	_AX = 0x0000;
	geninterrupt(0x33);
	if(_AX==0) {
		message.Message(TO_FILE|TO_SCREEN, "Mouse::Init  'Can't install mouse driver");
		return MOUSE_ERROR;
	}
	message.Message(TO_FILE, "Mouse::Init  'Mouse Driver installed");


	// set default values for object
	SetHorizontalMinMaxPosition(0, screen.XMax-1);
	SetVerticalMinMaxPosition(0, screen.YMax-1);

	SetPosition(screen.XMax/2, screen.YMax/2);
	last_x=0; last_y=0;

	cursor_colour[1] = RGB(255,255,255);
	cursor_colour[2] = RGB(0,0,0);
	cursor_colour[3] = RGB(100,100,100);

	SetSpeed(1);   // 1 = max speed

	SetCursorImage(arrow);

	Show();
	temporal_hide = 0;

	return MOUSE_OK;

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::GetMotionCounters(void) {

	_AX = 0x000B;
	geninterrupt(0x33);
	cx  += _CX;     // 0...65535       1/200 in = 1 mickey
	cy  += _DX;     // 0...65535
}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::GetButtonPress(void) {
	int reg;

	_AX = 0x0005;
	_BX = 0;  //boton 1
	geninterrupt(0x33);

	asm push DX;
	asm push CX;
	reg = _BX;
	pb[0]  = reg;    // 0,1,2,3...  numero de pulsaciones habidas
	asm pop CX;
	pbx[0] = _CX;    // 0...639
	asm pop dx;
	pby[0] = _DX;    // 0...199

	_AX = 0x0005;
	_BX = 1;  //boton 2
	geninterrupt(0x33);

	asm push DX;
	asm push CX;
	reg = _BX;
	pb[1]  = reg;    // 0,1,2,3...  numero de pulsaciones habidas
	asm pop CX;
	pbx[1] = _CX;    // 0...639
	asm pop DX;
	pby[1] = _DX;    // 0...199

	/*_AX = 0x0005;
	_BX = ??;  //boton 3:  no se puede leer.
	geninterrupt(0x33);
	dixie -> b3	  = _BX;    // 0,1,2,3...  numero de pulsaciones habidas
	dixie -> b3x  = _CX;    // 0...639
	dixie -> b3y  = _DX;    // 0...199    */

}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::GetButtonRelease(void) {
	int reg;

	_AX = 0x0006;
	_BX = 0;  //boton 1
	geninterrupt(0x33);

	asm push DX;
	asm push CX;
	reg = _BX;
	rb[0]	 = reg;    // 0,1,2,3...  numero de pulsaciones habidas
	asm pop CX;
	rbx[0] = _CX;    // 0...639
	asm pop DX;
	rby[0] = _DX;    // 0...199

	_AX = 0x0006;
	_BX = 1;  //boton 2
	geninterrupt(0x33);

	asm push DX;
	asm push CX;
	reg = _BX;
	rb[1]	 = reg;    // 0,1,2,3...  numero de pulsaciones habidas
	asm pop CX;
	rbx[1] = _CX;    // 0...639
	asm pop DX;
	rby[1] = _DX;    // 0...199

	/*_AX = 0x0005;
	_BX = ??;  //boton 3:  no se puede leer.
	geninterrupt(0x33);
	dixie -> rb3	  = _BX;    // 0,1,2,3...  numero de pulsaciones habidas
	dixie -> rb3x  = _CX;    // 0...639
	dixie -> rb3y  = _DX;    // 0...199    */

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
// mete en struct raton x,y,b1,b2,b3 los valores instantneos
void Mouse::GetInstantPosition(void) {
	_AX = 0x0003;
	geninterrupt(0x33);

	asm push BX;
	x  = _CX;
	y  = _DX;
	x/=8;
	y/=8;
	asm pop BX;

	asm push BX;
	ib[0] = _BX & 1;          // 0,1
	asm pop BX;

	asm push BX;
	ib[2] = (_BX & 2) >> 1;   // 0,1
	asm pop BX;

	ib[1] = (_BX & 4) >> 2;   // 0,1
}

void Mouse::SetPosition(int x0, int y0) {
	_CX = x0*8;
	asm push cx;
	_DX = y0*8;
	_AX = 4;
	asm pop cx;
	geninterrupt(0x33);

	x=x0; y=y0;

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::SavePosition() {
	GetInstantPosition();

	save_position_x = x;
	save_position_y = y;
}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::RestorePosition() {
	SetPosition(save_position_x, save_position_y);

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::SetCursorImage(unsigned char *image) {

	delete background_buffer;
	delete foreground_buffer;

	cursor_image = image;

	cursor_image_dx = cursor_image[0];
	cursor_image_dy = cursor_image[1];

	background_buffer =
		new unsigned char [ BLOCK_SIZE(cursor_image_dx, cursor_image_dy) ];
	foreground_buffer =
		new unsigned char [ BLOCK_SIZE(cursor_image_dx, cursor_image_dy) ];

}




/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::SetSpeed(int speed) {   // speed = 1,2,3,...
	// SetMickeyPixelRatio
	_CX = speed; // horizontal ratio
	_DX = speed; // vertical ratio
	_AX =0xF;
	geninterrupt(0x33);

}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::RefreshCursor(void) {

	GetInstantPosition();

//	screen.GotoXY(0,300);
//	screen.PrintF("hide=%i t-hide=%i", hide, temporal_hide);
	if(hide|| (x == last_x && y == last_y)) return;
	if(temporal_hide) return;

	restore_background();
	save_background();
	print_cursor();

	last_x = x;
	last_y = y;

}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::print_cursor(void) {

	int xx,yy;
	int index = 0;
	RGB *rgbp = (RGB*)(foreground_buffer + 4);

	screen.GraphicDevice::GetBlock(foreground_buffer, x-1, y-1, cursor_image_dx, cursor_image_dy);

	for(yy=0; yy<cursor_image_dy; yy++) {
		for(xx=0; xx<cursor_image_dx; xx++) {
			if(cursor_image[index+2]!=0)
				*(rgbp + index) = cursor_colour[cursor_image[index+2]];
			//else *(rgbp + index) = RGB(90,90,90);
			index++;
		}
	}

	screen.GraphicDevice::SetBlock(foreground_buffer, x-1, y-1);


/*
	for(yy=0; yy<cursor_image_dy; yy++) {
		for(xx=0; xx<cursor_image_dx; xx++) {
			if(cursor_image[++index]!=0) screen.GraphicDevice::SetPixel(x-1+xx,y-1+yy, cursor_colour[cursor_image[index]]);
		}
	}
*/

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::save_background(void) {
	screen.GraphicDevice::GetBlock(background_buffer, x-1, y-1, cursor_image_dx, cursor_image_dy);
}

/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::restore_background(void) {
		screen.GraphicDevice::SetBlock(background_buffer, last_x-1, last_y-1);
}


/*----------------------------------------------------------------------------
																HIDE / SHOW
----------------------------------------------------------------------------*/
void Mouse::Hide(void) {
	restore_background();
	hide=1;
}

void Mouse::Show(void) {
	save_background();
	print_cursor();
	hide=0;
	last_x = x;
	last_y = y;
}

/*----------------------------------------------------------------------------
												TEMPORAL   HIDE / SHOW

	Between TemporalHide() and TemporalShow()
	no other Mouse functions should be called !
----------------------------------------------------------------------------*/
void Mouse::TemporalHide(int xx, int yy, int dxx, int dyy) {

	if(temporal_hide) {
		message.Message(TO_FILE,"ERROR: Double Temporal_hide call");
		return;
	}
	if(hide) return;

	if(x > xx+dxx) return;
	if(y > yy+dyy) return;
	if(x+cursor_image_dx <= xx+1) return;
	if(y+cursor_image_dy <= yy+1) return;

	restore_background();
	temporal_hide=1;

}

void Mouse::TemporalShow(void) {
	if(!temporal_hide) return;
	temporal_hide = 0;
	save_background();
	print_cursor();

}


/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
void Mouse::SetVerticalMinMaxPosition(int min, int max) {

 //INT 33,8 - Set Mouse Vertical Min/Max Position
	min*=8;
	max*=8;

	_DX = max; //maximum vertical position
	_CX = min; //minimum vertical position
	_AX = 8;

	geninterrupt(0x33);

}


void Mouse::SetHorizontalMinMaxPosition(int min, int max) {

 //INT 33,7 - Set Mouse Horizontal Min/Max Position
	min*=8;
	max*=8;

	_CX = min;     //minimum horizontal position
	_DX = max; //maximum horizontal position
	_AX = 7;

	geninterrupt(0x33);

}


