//#define NO_REGION	-1
#include "RGB.hpp"

const int MOUSE_ERROR = 1;
const int MOUSE_OK    = 0;

class Mouse {
	protected:
		RGB cursor_colour[4];

		unsigned char cursor_image_dx, cursor_image_dy;
		unsigned char *background_buffer;
		unsigned char *foreground_buffer;
		unsigned char *cursor_image;    // format: char dx, char dy, char data[]
																		//      data[i]=  0   keep background colour
																		//						 =  1   pixel colour defined by cursor_colour1
																		//						 =  2   pixel colour defined by cursor_colour2

		int last_x, last_y;     //  coordinates for the background to be restored
		int save_position_x, save_position_y;   // for 'save' and 'restore' position



		void restore_background(void);
		void save_background(void);
		void print_cursor(void);




	public:
		int hide, temporal_hide;
//  posicion instantnea (x,y):  GetInstantPosition(RATON pixie);
//  x=[0,639]    y=[0,199]
		int x; int y;

//  pulsacin instantnea (ib1,ib2,ib3): GetInstantPosition(RATON dixie);
//  ib[i]=[0,1]
		int ib[3];

//  contador de mickeys (1/200 in.): MotionCounters(RATON perez);
//  cx,cy=[0,65535]
		int cx;	int cy;

// pb[i]=nmero veces pulsado desde la ltima llamada a ButtonPress();
//  (pbx[i],pby[i])= coordenadas de la ltima pulsacin.
		int pb[3];
		int pbx[3];
		int pby[3];

// rb[i]=nmero veces soltado desde la ltima llamada a ButtonRelease();
//  (pb1x,pb1y)= coordenadas de la ltima liberacin del botn.
		int rb[3];
		int rbx[3];
		int rby[3];




/*----------------------------------------------------------------------------

----------------------------------------------------------------------------*/
	public:
		Mouse(void);
		~Mouse();

		int Init(void);

		void SetCursorImage(unsigned char *);

		void SetPosition(int x0, int y0);
		void SavePosition();
		void RestorePosition();

		void RefreshCursor(void);
		void Hide(void);
		void Show(void);
		void TemporalHide(int x,int y, int dx, int dy);
		void TemporalShow(void);

		void SetColour1(RGB rgb);
		void SetColour2(RGB rgb);

		void SetSpeed(int speed); // speed = 1,2,3,...

		void GetInstantPosition(void);
		void GetMotionCounters(void);
		void GetButtonPress(void);
		void GetButtonRelease(void);

		void SetHorizontalMinMaxPosition(int min, int max);
		void SetVerticalMinMaxPosition(int min, int max);


};

