#include "key_code.hpp"

#include "BGraph.hpp"
#include "RGB.hpp"
#include "Screen.hpp"
#include "GraphDev.hpp"
#include "Message.hpp"
#include "Image.hpp"
#include "ImgFile.hpp"
#include "ImgXMS.hpp"
#include "XMS.hpp"
#include "Pool.hpp"
#include "Mouse.hpp"
#include "Window.hpp"
#include "Progress.hpp"

// Global declarations
Screen screen;
MessageHandler message("PLAYTGA.TMP", TO_FILE | TO_SCREEN);
XMS xms;
Pool pool;
Mouse mouse;

#include <iostream.h>
#include <conio.h>
#include <dos.h>
#include <process.h>
#include <stdlib.h>

#include <stdio.h>
#include <string.h>


#define ABS(X) ((X)<0? (-(X)):(X))


void shut_down(void);
void show(char *file_name);

/*----------------------------------------------------------------------------
															MAIN
----------------------------------------------------------------------------*/

int slide=0;

int main(int argc, char *argv[]) {

	if(argc != 2) {
		printf("\
PlayTGA 3.0 displays a TGA file\n\
\n\
Syntax:  playtga <file_name>\n\
Example: playtga image.tga\n\
\n\
Programmed by Manuel Guilln Gonzlez\n");
		return 0;
	}


	// test if file is available
	FILE *dummy;
	if((dummy = fopen(argv[1], "rb")) == NULL) {
		printf("Cannot open input file <%s>.\n", argv[1]);
		return 1;
	}
	fclose(dummy);


printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");

	int mode = 0x112;
	screen.PrintF("\
PLAYTGA 3.0\n\
\n\
1. 115h  800x600\n\
2. 112h  640x480\n\
3. 225h  512x384\n\
4. 215h  320x240\n\
5. 10Fh  320x200\n\
0. Slide 640x480\n\n");

	switch(message.Message(WAIT_KEY | BEEP | TO_SCREEN, "Press video mode number.")) {
		case '0': slide=1;
		case '2': mode=0x112; break;
		case '1': mode=0x115; break;
		case '5': mode=0x10F; break;
		case '4': mode=0x215; break;
		case '3': mode=0x225; break;
	}

	if(screen.InitGraph(mode) == VESA_ERROR) {
		message.Message(EXIT | TO_FILE | TO_SCREEN, "MAIN: Cannot initialise video mode %Xh", mode);
	}


/* Init mouse  */
	if(mouse.Init() != MOUSE_OK) message.Message(EXIT | TO_FILE | TO_SCREEN, "MAIN:  'cannot initialise mouse");


	if(slide) {
		ImgXMS img_slide;
		img_slide.Open(argv[1],READ_WRITE,0);
		screen.CopyBlock(0,0,img_slide);
		while(!kbhit()) mouse.RefreshCursor();
		if(getch()==0x1b) shut_down();
	}

//	screen.Cls();
	show(argv[1]);

	shut_down();

}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void shut_down(void) {

	screen.CloseGraph();
//	screen.PrintF("VESAVersion= %s\n", screen.VESAVersion);
//	screen.PrintF("VideoCardInfo= %s\n", screen.VideoCardInfo);
//	getch();
	message.DeleteFile();
	exit(EXIT_SUCCESS);

}







/*----------------------------------------------------------------------------
			show()
----------------------------------------------------------------------------*/
void show(char *file_name) {
	int resize=0;
	int incre=1;
	int old_x=0, old_y=0;
	int c;

	float mod_zoom=1;
	float mod_zoom_last=1;
	screen.Cls();

	char win_title[100];
	char buffer[100];


	Window w2("", 0,0, 100,100);
	if(w2.img.Open(file_name) == ERROR) return;

	strcpy(win_title, file_name);
	sprintf(buffer, "  %ix%i", w2.img.XMax, w2.img.YMax);
	strcat(win_title, buffer);

	w2.SetTitle(win_title);

	w2.Move(WIN_FRAME_WIDTH, WIN_FRAME_WIDTH+1+CHAR_HEIGHT);
	w2.Resize();
	w2.Print();
	w2.Refresh();

	int last_mouse_cx=0, var_x;
	int last_mouse_cy=0, var_y;

	for(;;) {
		while(!kbhit()) {
			if(incre>1) incre--;
			mouse.RefreshCursor();
			//screen.GotoXY(0,screen.YMax-3*CHAR_HEIGHT);
			//screen.PrintF("m.x=%3.3i  m.y=%3.3i\n", mouse.x,mouse.y);
			//screen.PrintF("Zoom=%5.5f", mod_zoom);

			mouse.GetMotionCounters();
			if(mouse.ib[0]) {
				//mouse.GetInstantPosition();
				var_x = mouse.cx - last_mouse_cx;
				var_y = mouse.cy - last_mouse_cy;

				#define LIM 80
				if(var_x > LIM)  var_x = LIM;
				if(var_x < -LIM) var_x = -LIM;
				if(var_y > LIM)  var_y = LIM;
				if(var_y < -LIM) var_y = -LIM;

				w2.shown.x += var_x;
				w2.shown.y += var_y;
				if(last_mouse_cx!=mouse.cx || last_mouse_cy!=mouse.cy) ungetch('#');

			}

			last_mouse_cx = mouse.cx;
			last_mouse_cy = mouse.cy;


			if(mouse.ib[2]) {
				//screen.GotoXY(0,screen.YMax-CHAR_HEIGHT);
				//w2.print_hyper(mouse.x, mouse.y);
				/*mouse.GetMotionCounters();
				last_mouse_cy = mouse.cy;
				while(mouse.ib[2]) {
					mouse.GetInstantPosition();
					mouse.GetMotionCounters();
					w2.shown.zoom = mouse.cy - last_mouse_cy;
					if(w2.shown.zoom<1) { w2.shown.zoom=1; last_mouse_cy=mouse.cy; }

					mouse.Hide();
					w2.Refresh();
					mouse.Show();
					//screen.CopyBlockZoom(180,100, i1, x,y, 150,150, zoom);
				} */
			}

		} // while !kbhit()

		if((c=getch())==0) c=getch()<<8;
		switch(c) {
			case 0x1b: return;

			case CUR_UP:
			case 'q': w2.shown.y-=incre; incre+=3; break;

			case CUR_DOWN:
			case 'a': w2.shown.y+=incre; incre+=3; break;

			case CUR_LEFT:
			case 'o': w2.shown.x-=incre; incre+=3 ;break;

			case CUR_RIGHT:
			case 'p': w2.shown.x+=incre; incre+=3 ;break;

			case '+':
				if(w2.shown.zoom == -1) w2.shown.zoom = 1;
				w2.shown.zoom++;
				resize=1;
				break;
			case '-':
				if(w2.shown.zoom == 1) w2.shown.zoom = -1;
				w2.shown.zoom--;
				resize=1;
				break;
			//case ' ': screen.Cls(); break;
			//case 'r':
			//	break;

//			case ' ':


		}

		while(kbhit()) getch();

		if(resize) {
			int old_dx = w2.dx;
			int old_dy = w2.dy;
			resize=0;

			screen.Cls();
			mod_zoom = w2.shown.zoom;
			if(w2.shown.zoom == 0 ) mod_zoom = 1;
			if(w2.shown.zoom < 0) mod_zoom = 1.0 / -mod_zoom;

			//w2.shown.x = ((w2.shown.x+old_dx/2) / mod_zoom_last) * mod_zoom;
			//w2.shown.y = ((w2.shown.y+old_dy/2) / mod_zoom_last) * mod_zoom;
			mod_zoom_last = mod_zoom;

			w2.Resize();
			w2.Print();
			w2.Refresh();
		}



		if(w2.shown.x<0) w2.shown.x=0;
		if(w2.shown.x > w2.img.XMax-w2.dx/mod_zoom) w2.shown.x = w2.img.XMax-w2.dx/mod_zoom;

		if(w2.shown.y<0) w2.shown.y=0;
		if(w2.shown.y > w2.img.YMax-w2.dy/mod_zoom) w2.shown.y = w2.img.YMax-w2.dy/mod_zoom;


		if(w2.shown.x != old_x || w2.shown.y != old_y) {
			w2.Refresh();
			old_x = w2.shown.x;
			old_y = w2.shown.y;
		}

	}


}



