#include "Pool.hpp"
#include "Message.hpp"
#include <alloc.h>

extern MessageHandler message;

unsigned char *Pool::buffer=NULL;
unsigned int Pool::size=0;
char Pool::buffer_allocated=0;


Pool::Pool(void) {
	size=0;
	Pool::Extend(200);   // default size
}

Pool::~Pool() {
	if(buffer_allocated) free(buffer);
}

void Pool::Extend(unsigned int new_size) {

	if(new_size>size) {
		if(buffer_allocated) free(buffer);
		size=0;
		buffer_allocated=0;
		if((buffer = (unsigned char *)malloc(new_size)) == NULL) {
			message.Message(EXIT|TO_FILE|TO_SCREEN, "Out of memory trying to allocate <%ubytes>", new_size);
		}
		size=new_size;
	}
	message.Message(TO_FILE, "Pool::Extend   'reallocated buffer (%u Bytes)", size);

}
