#include "RGB.hpp"
#include "GraphDev.hpp"
#include "BGraph.hpp"

class Screen : public BGraph {

	public:

		static int is_graphic_mode;   // set to 0 when in text mode
		static int old_video_mode;		// to restore on CloseGrpah()

	public:
		Screen(void);
		~Screen(void);


		/*----------------------------------------------------------------------------
				Initialising Video Mode
		----------------------------------------------------------------------------*/
		int InitGraph(int mode);
		void CloseGraph(void);

		/*------------------------------------------------------------------------
				Smart Print functions (graph/text video mode)
		------------------------------------------------------------------------*/
		void PrintF(char *format, ...);
		void PrintString(char *string);



		/*------------------------------------------------------------------------
				Mouse temporal Hide   Functions
		------------------------------------------------------------------------*/
		void SetPixel(int x, int y, RGB &rgb);
		RGB GetPixel(int x, int y);
		void SetHLine(unsigned char *source, int x, int y, int dx);
		void GetHLine(unsigned char *dest, int x, int y, int dx);
		//---------------------------------------------------------------
		void Line(int x1, int y1, int x2, int y2, RGB& rgb);
		void HLine(int x0, int y0, int dx, RGB& rgb);
		void VLine(int x, int y, int dy, RGB& rgb);
		void Bar(int x, int y, int dx, int dy, RGB rgb);
		void Rectangle(int x, int y, int dx, int dy, RGB rgb);
		void Rectangle(RGB rgb);  // 0,0, XMax,YMax
		void Cls(RGB rgb=RGB(0,0,0));

		// the buffer size required can be calculated using the macro IMAGE_SIZE(DX,DY)

		void GetBlock(unsigned char *buffer, int x, int y, int dx, int dy);
		void SetBlock(unsigned char *buffer, int x, int y);

		// The calling instance is the destiny
		//  e.g. screen.CopyBlock(0,0, i1,0,0, 20,20)
		// Can be used this way: CopyBlock(x_dest, y_dest, GraphicDevice &gd_org);
		//  and it will copy the whole source image.

		void CopyBlock( int x_dest, int y_dest,
			GraphicDevice &gd_org,  int x_org=0,  int y_org=0,
			int dx=-1, int dy=-1); // default (dx,dy) = maximum possible block

		void CopyBlockZoom( int x_dest, int y_dest,
										GraphicDevice &gd_org,  int x_org,  int y_org,
										int dx, int dy, int zoom=1);

};
